diff --git a/SHADE_Engine/src/Graphics/MiddleEnd/Batching/SHBatch.cpp b/SHADE_Engine/src/Graphics/MiddleEnd/Batching/SHBatch.cpp
index 476351c9..09fde60f 100644
--- a/SHADE_Engine/src/Graphics/MiddleEnd/Batching/SHBatch.cpp
+++ b/SHADE_Engine/src/Graphics/MiddleEnd/Batching/SHBatch.cpp
@@ -30,184 +30,199 @@ of DigiPen Institute of Technology is prohibited.
 
 namespace SHADE
 {
-    /*---------------------------------------------------------------------------------*/
-    /* SHBatch - Usage Functions                                                       */
-    /*---------------------------------------------------------------------------------*/
-    SHBatch::SHBatch(Handle<SHVkPipeline> pipeline)
+  /*---------------------------------------------------------------------------------*/
+  /* SHBatch - Usage Functions                                                       */
+  /*---------------------------------------------------------------------------------*/
+  SHBatch::SHBatch(Handle<SHVkPipeline> pipeline)
     : pipeline{ pipeline }
-    {
-        if (!pipeline)
-            throw std::invalid_argument("Attempted to create a SHBatch with an invalid SHPipeline!");
+  {
+    if (!pipeline)
+      throw std::invalid_argument("Attempted to create a SHBatch with an invalid SHPipeline!");
 
-        // Mark all as dirty
-        setAllDirtyFlags();
+    // Mark all as dirty
+    setAllDirtyFlags();
+  }
+
+  void SHBatch::Add(const SHRenderable* renderable)
+  {
+    // Check if we have a SubBatch with the same mesh yet
+    auto subBatch = std::find_if(subBatches.begin(), subBatches.end(), [&](const SHSubBatch& batch)
+      {
+        return batch.Mesh == renderable->Mesh;
+      });
+
+    // Create one if not found
+    if (subBatch == subBatches.end())
+    {
+      subBatches.emplace_back(renderable->Mesh);
+      subBatch = subBatches.end() - 1;
     }
 
-    void SHBatch::Add(const SHRenderable* renderable)
-    {
-        // Check if we have a SubBatch with the same mesh yet
-        auto subBatch = std::find_if(subBatches.begin(), subBatches.end(), [&](const SHSubBatch& batch)
-        {
-            return batch.Mesh == renderable->Mesh;
-        });
+    // Add renderable in
+    subBatch->Renderables.insert(renderable->GetEID());
 
-        // Create one if not found
-        if (subBatch == subBatches.end())
+    // Also add material instance in
+    referencedMatInstances.insert(renderable->GetMaterial());
+
+    // Mark all as dirty
+    setAllDirtyFlags();
+  }
+
+  void SHBatch::Remove(const SHRenderable* renderable)
+  {
+    // Check if we have a SubBatch with the same mesh yet
+    auto subBatch = std::find_if(subBatches.begin(), subBatches.end(), [&](const SHSubBatch& batch)
+      {
+        return batch.Mesh == renderable->Mesh;
+      });
+
+    // Attempt to remove if it exists
+    if (subBatch == subBatches.end())
+      return;
+
+    subBatch->Renderables.erase(renderable->GetEID());
+
+    // Check if other renderables in subBatches contain the same material instance
+    bool matUnused = true;
+    for (const auto& sb : subBatches)
+      for (const auto& rendId : sb.Renderables)
+      {
+        auto rend = SHComponentManager::GetComponent<SHRenderable>(rendId);
+        if (rend)
         {
-            subBatches.emplace_back(renderable->Mesh);
-            subBatch = subBatches.end() - 1;
+          if (rend->GetMaterial() == renderable->GetMaterial())
+          {
+            matUnused = false;
+            break;
+          }
         }
+        else
+        {
+          SHLOG_WARNING("[SHBatch] Entity with a missing SHRenderable found!");
+        }
+      }
 
-        // Add renderable in
-        subBatch->Renderables.insert(renderable);
+    // Material is no longer in this library, so we remove it
+    if (matUnused)
+      referencedMatInstances.erase(renderable->WasMaterialChanged() ? renderable->GetPrevMaterial() : renderable->GetMaterial());
 
-        // Also add material instance in
-        referencedMatInstances.insert(renderable->GetMaterial());
+    // Mark all as dirty
+    setAllDirtyFlags();
+  }
 
-        // Mark all as dirty
-        setAllDirtyFlags();
+  void SHBatch::Clear()
+  {
+    subBatches.clear();
+
+    // Clear CPU buffers
+    drawData.clear();
+    transformData.clear();
+    instancedIntegerData.clear();
+    matPropsData.reset();
+    matPropsDataSize = 0;
+
+
+    // Clear GPU buffers
+    for (int i = 0; i < SHGraphicsConstants::NUM_FRAME_BUFFERS; ++i)
+    {
+      drawDataBuffer[i].Free();
+      transformDataBuffer[i].Free();
+      instancedIntegerBuffer[i].Free();
+      matPropsBuffer[i].Free();
+    }
+  }
+
+  void SHBatch::UpdateMaterialBuffer(uint32_t frameIndex, Handle<SHVkDescriptorPool> descPool)
+  {
+    if (frameIndex >= SHGraphicsConstants::NUM_FRAME_BUFFERS)
+    {
+      SHLOG_WARNING("[SHBatch] Attempted to update transform buffers with an invalid frame index.");
+      return;
     }
 
-    void SHBatch::Remove(const SHRenderable* renderable)
+    // Check if there are even material properties to update
+    if (!matPropsData)
+      return;
+
+    // Check if any materials have changed
+    bool hasChanged = false;
+    for (const auto& material : referencedMatInstances)
     {
-        // Check if we have a SubBatch with the same mesh yet
-        auto subBatch = std::find_if(subBatches.begin(), subBatches.end(), [&](const SHSubBatch& batch)
-        {
-            return batch.Mesh == renderable->Mesh;
-        });
-
-        // Attempt to remove if it exists
-        if (subBatch == subBatches.end())
-            return;
-
-        subBatch->Renderables.erase(renderable);
-
-        // Check if other renderables in subBatches contain the same material instance
-        bool matUnused = true;
-        for (const auto& sb : subBatches)
-        for (const auto& rend : sb.Renderables)
-        {
-            if (rend->GetMaterial() == renderable->GetMaterial())
-            {
-                matUnused = false;
-                break;
-            }
-        }
-
-        // Material is no longer in this library, so we remove it
-        if (matUnused)
-            referencedMatInstances.erase(renderable->GetMaterial());
-
-        // Mark all as dirty
-        for (bool& dirt : isDirty)
-            dirt = true;
+      if (material->HasChanged())
+      {
+        hasChanged = true;
+        break;
+      }
     }
 
-    void SHBatch::Clear()
+    // We need to update all the material buffers if the materials have changed
+    if (hasChanged)
     {
-        subBatches.clear();
-
-        // Clear CPU buffers
-        drawData.clear();
-        transformData.clear();
-        instancedIntegerData.clear();
-        matPropsData.reset();
-        matPropsDataSize = 0;
-
-
-        // Clear GPU buffers
-        for (int i = 0; i < SHGraphicsConstants::NUM_FRAME_BUFFERS; ++i)
-        {
-            drawDataBuffer[i].Free();
-            transformDataBuffer[i].Free();
-            instancedIntegerBuffer[i].Free();
-            matPropsBuffer[i].Free();
-        }
+      for (auto& dirt : matBufferDirty)
+        dirt = true;
     }
 
-	void SHBatch::UpdateMaterialBuffer(uint32_t frameIndex, Handle<SHVkDescriptorPool> descPool)
-	{
-		if (frameIndex >= SHGraphicsConstants::NUM_FRAME_BUFFERS)
-		{
-			SHLOG_WARNING("[SHBatch] Attempted to update transform buffers with an invalid frame index.");
-			return;
-		}
+    // Check if this frame's buffer is dirty
+    if (!matBufferDirty[frameIndex])
+      return;
 
-        // Check if there are even material properties to update
-        if (!matPropsData)
-            return;
-
-        // Check if any materials have changed
-        bool hasChanged = false;
-        for (const auto& material : referencedMatInstances)
+    // Build CPU Buffer
+    char* propsCurrPtr = matPropsData.get();
+    for (auto& subBatch : subBatches)
+      for (auto rendId : subBatch.Renderables)
+      {
+        const SHRenderable* renderable = SHComponentManager::GetComponent<SHRenderable>(rendId);
+        if (renderable)
         {
-            if (material->HasChanged())
-            {
-                hasChanged = true;
-                break;
-            }
+          renderable->GetMaterial()->ExportProperties(propsCurrPtr);
         }
-
-        // We need to update all the material buffers if the materials have changed
-        if (hasChanged)
+        else
         {
-            for (auto& dirt : matBufferDirty)
-			    dirt = true;
+          SHLOG_WARNING("[SHBatch] Entity with a missing SHRenderable found!");
         }
+        propsCurrPtr += singleMatPropAlignedSize;
+      }
 
-        // Check if this frame's buffer is dirty
-        if (!matBufferDirty[frameIndex])
-            return;
+    // Transfer to GPU
+    rebuildMaterialBuffers(frameIndex, descPool);
 
-		// Build CPU Buffer
-		char* propsCurrPtr = matPropsData.get();
-		for (auto& subBatch : subBatches)
-		for (const SHRenderable* renderable : subBatch.Renderables)
-		{
-			renderable->GetMaterial()->ExportProperties(propsCurrPtr);
-			propsCurrPtr += singleMatPropAlignedSize;
-		}
-        
-        // Transfer to GPU
-        rebuildMaterialBuffers(frameIndex, descPool);
+    // This frame is updated
+    matBufferDirty[frameIndex] = false;
+  }
 
-        // This frame is updated
-        matBufferDirty[frameIndex] = false;
-	}
-
-	void SHBatch::UpdateTransformBuffer(uint32_t frameIndex)
+  void SHBatch::UpdateTransformBuffer(uint32_t frameIndex)
+  {
+    if (frameIndex >= SHGraphicsConstants::NUM_FRAME_BUFFERS)
     {
-        if (frameIndex >= SHGraphicsConstants::NUM_FRAME_BUFFERS)
-        {
-            SHLOG_WARNING("[SHBatch] Attempted to update transform buffers with an invalid frame index.");
-            return;
-        }
-
-        // Reset Transform Data
-        transformData.clear();
-
-        // Populate on the CPU
-        for (auto& subBatch : subBatches)
-        for (const SHRenderable* renderable : subBatch.Renderables)
-        {
-            // Transform
-            auto transform = SHComponentManager::GetComponent<SHTransformComponent>(renderable->GetEID());
-            if (!transform)
-            {
-                SHLOG_WARNING("[SHBatch] Entity contianing a SHRenderable with no SHTransformComponent found!");
-                transformData.emplace_back();
-            }
-            else
-            {
-                transformData.emplace_back(transform->GetTRS());
-            }
-        }
-
-        // Transfer to GPU
-        if (transformDataBuffer[frameIndex])
-          transformDataBuffer[frameIndex]->WriteToMemory(transformData.data(), static_cast<uint32_t>(transformData.size() * sizeof(SHMatrix)), 0, 0);
+      SHLOG_WARNING("[SHBatch] Attempted to update transform buffers with an invalid frame index.");
+      return;
     }
 
+    // Reset Transform Data
+    transformData.clear();
+
+    // Populate on the CPU
+    for (auto& subBatch : subBatches)
+      for (auto rendId : subBatch.Renderables)
+      {
+        // Transform
+        auto transform = SHComponentManager::GetComponent<SHTransformComponent>(rendId);
+        if (transform)
+        {
+          transformData.emplace_back(transform->GetTRS());
+        }
+        else
+        {
+          SHLOG_WARNING("[SHBatch] Entity contianing a SHRenderable with no SHTransformComponent found!");
+          transformData.emplace_back();
+        }
+      }
+
+    // Transfer to GPU
+    if (transformDataBuffer[frameIndex])
+      transformDataBuffer[frameIndex]->WriteToMemory(transformData.data(), static_cast<uint32_t>(transformData.size() * sizeof(SHMatrix)), 0, 0);
+  }
+
   void SHBatch::UpdateInstancedIntegerBuffer(uint32_t frameIndex)
   {
     if (frameIndex >= SHGraphicsConstants::NUM_FRAME_BUFFERS)
@@ -221,11 +236,12 @@ namespace SHADE
 
     // Populate on the CPU
     for (auto& subBatch : subBatches)
-      for (const SHRenderable* renderable : subBatch.Renderables)
+      for (auto rendId : subBatch.Renderables)
       {
+        auto* renderable = SHComponentManager::GetComponent<SHRenderable>(rendId);
         instancedIntegerData.emplace_back(SHInstancedIntegerData
           {
-            renderable->GetEID(),
+            rendId,
             renderable->GetLightLayer()
           }
         );
@@ -238,213 +254,222 @@ namespace SHADE
   }
 
   void SHBatch::Build(Handle<SHVkLogicalDevice> _device, Handle<SHVkDescriptorPool> descPool, uint32_t frameIndex)
+  {
+    if (frameIndex >= SHGraphicsConstants::NUM_FRAME_BUFFERS)
     {
-        if (frameIndex >= SHGraphicsConstants::NUM_FRAME_BUFFERS)
-        {
-            SHLOG_WARNING("[SHBatch] Attempted to update build batch buffers with an invalid frame index.");
-            return;
-        }
-
-        // Save logical device
-        device = _device;
-
-        // No need to build as there are no changes
-        if (!isDirty[frameIndex])
-            return;
-
-        // Count number of elements
-        size_t numTotalElements = 0;
-        for (const auto& subBatch : subBatches)
-        {
-            numTotalElements += subBatch.Renderables.size();
-        }
-
-        // Generate CPU buffers if there are changes
-        if (isCPUBuffersDirty)
-        {
-            // - Draw data
-            drawData.reserve(subBatches.size());
-            drawData.clear();
-            // - Transform data
-            transformData.reserve(numTotalElements);
-            transformData.clear();
-            // - EID data
-            instancedIntegerData.reserve(numTotalElements);
-            instancedIntegerData.clear();
-
-
-            // - Material Properties Data
-		    const Handle<SHShaderBlockInterface> SHADER_INFO = pipeline->GetPipelineLayout()->GetShaderBlockInterface
-		    (
-			    SHGraphicsConstants::DescriptorSetIndex::PER_INSTANCE,
-			    SHGraphicsConstants::DescriptorSetBindings::BATCHED_PER_INST_DATA,
-			    vk::ShaderStageFlagBits::eFragment
-		    );
-            const bool EMPTY_MAT_PROPS = !SHADER_INFO;
-            Byte matPropTotalBytes = 0;
-            if (!EMPTY_MAT_PROPS)
-            {
-                singleMatPropSize = SHADER_INFO->GetBytesRequired();
-                singleMatPropAlignedSize = device->PadSSBOSize(static_cast<uint32_t>(singleMatPropSize));
-                matPropTotalBytes = numTotalElements * singleMatPropAlignedSize;
-                if (matPropsDataSize < matPropTotalBytes)
-                {
-                    matPropsData.reset(new char[matPropTotalBytes]);
-                    matPropsDataSize = matPropTotalBytes;
-                }
-            }
-
-            // Build Sub Batches
-            uint32_t nextInstanceIndex = 0;
-            char* propsCurrPtr = matPropsData.get();
-            for (auto& subBatch : subBatches)
-            {
-                // Create command
-                drawData.emplace_back(vk::DrawIndexedIndirectCommand
-                {
-                    .indexCount = subBatch.Mesh->IndexCount,
-                    .instanceCount = static_cast<uint32_t>(subBatch.Renderables.size()),
-                    .firstIndex = subBatch.Mesh->FirstIndex,
-                    .vertexOffset = subBatch.Mesh->FirstVertex,
-                    .firstInstance = nextInstanceIndex++
-                });
-
-                // Fill in buffers (CPU)
-                for (const SHRenderable* renderable : subBatch.Renderables)
-                {
-                    // Transform
-                    EntityID eid = renderable->GetEID();
-                    auto transform = SHComponentManager::GetComponent_s<SHTransformComponent>(eid);
-                    if (!transform)
-                    {
-                        SHLOG_WARNING("[SHBatch] Entity contianing a SHRenderable with no SHTransformComponent found!");
-                        transformData.emplace_back();
-                    }
-                    else
-                    {
-                        transformData.emplace_back(transform->GetTRS());
-                    }
-
-                    instancedIntegerData.emplace_back(SHInstancedIntegerData
-                      {
-                        eid,
-                        renderable->GetLightLayer()
-                      }
-                    );
-
-                    // Material Properties
-                    if (!EMPTY_MAT_PROPS)
-                    {
-                        renderable->GetMaterial()->ExportProperties(propsCurrPtr);
-                        propsCurrPtr += singleMatPropAlignedSize;
-                    }
-                }
-            }
-
-            // Successfully update CPU buffers
-            isCPUBuffersDirty = false;
-        }
-
-        // Send all buffered data to the GPU buffers
-        using BuffUsage = vk::BufferUsageFlagBits;
-        // - Draw Data
-        const uint32_t DRAW_DATA_BYTES = static_cast<uint32_t>(drawData.size() * sizeof(vk::DrawIndexedIndirectCommand));
-        SHVkUtil::EnsureBufferAndCopyHostVisibleData
-        (
-            device, drawDataBuffer[frameIndex], drawData.data(), DRAW_DATA_BYTES,
-            BuffUsage::eIndirectBuffer
-        );
-        // - Transform Buffer
-        const uint32_t TF_DATA_BYTES = static_cast<uint32_t>(transformData.size() * sizeof(SHMatrix));
-        SHVkUtil::EnsureBufferAndCopyHostVisibleData
-        (
-            device, transformDataBuffer[frameIndex], transformData.data(), TF_DATA_BYTES,
-            BuffUsage::eVertexBuffer
-        );
-        const uint32_t EID_DATA_BYTES = static_cast<uint32_t>(instancedIntegerData.size() * sizeof(SHInstancedIntegerData));
-        SHVkUtil::EnsureBufferAndCopyHostVisibleData
-        (
-          device, instancedIntegerBuffer[frameIndex], instancedIntegerData.data(), EID_DATA_BYTES,
-          BuffUsage::eVertexBuffer
-        );
-        // - Material Properties Buffer
-        rebuildMaterialBuffers(frameIndex, descPool);
-
-        // Mark this frame as no longer dirty
-        isDirty[frameIndex] = false;
+      SHLOG_WARNING("[SHBatch] Attempted to update build batch buffers with an invalid frame index.");
+      return;
     }
 
-    /*---------------------------------------------------------------------------------*/
-    /* SHBatch - Usage Functions                                                       */
-    /*---------------------------------------------------------------------------------*/
-    void SHBatch::Draw(Handle<SHVkCommandBuffer> cmdBuffer, uint32_t frameIndex)
-    {
-      if (frameIndex >= SHGraphicsConstants::NUM_FRAME_BUFFERS)
-        {
-            SHLOG_WARNING("[SHBatch] Attempted to draw a batch with an invalid frame index.");
-            return;
-        }
+    // Save logical device
+    device = _device;
 
-        // Bind all required objects before drawing
-        static std::array<uint32_t, 1> dynamicOffset { 0 };
-        cmdBuffer->BindPipeline(pipeline);
-        cmdBuffer->BindVertexBuffer(SHGraphicsConstants::VertexBufferBindings::TRANSFORM,    transformDataBuffer[frameIndex], 0);
-        cmdBuffer->BindVertexBuffer(SHGraphicsConstants::VertexBufferBindings::INTEGER_DATA, instancedIntegerBuffer[frameIndex], 0);
-        if (matPropsDescSet[frameIndex])
+    // No need to build as there are no changes
+    if (!isDirty[frameIndex])
+      return;
+
+    // Count number of elements
+    size_t numTotalElements = 0;
+    for (const auto& subBatch : subBatches)
+    {
+      numTotalElements += subBatch.Renderables.size();
+    }
+
+    // Generate CPU buffers if there are changes
+    if (isCPUBuffersDirty)
+    {
+      // - Draw data
+      drawData.reserve(subBatches.size());
+      drawData.clear();
+      // - Transform data
+      transformData.reserve(numTotalElements);
+      transformData.clear();
+      // - EID data
+      instancedIntegerData.reserve(numTotalElements);
+      instancedIntegerData.clear();
+
+
+      // - Material Properties Data
+      const Handle<SHShaderBlockInterface> SHADER_INFO = pipeline->GetPipelineLayout()->GetShaderBlockInterface
+      (
+        SHGraphicsConstants::DescriptorSetIndex::PER_INSTANCE,
+        SHGraphicsConstants::DescriptorSetBindings::BATCHED_PER_INST_DATA,
+        vk::ShaderStageFlagBits::eFragment
+      );
+      const bool EMPTY_MAT_PROPS = !SHADER_INFO;
+      Byte matPropTotalBytes = 0;
+      if (!EMPTY_MAT_PROPS)
+      {
+        singleMatPropSize = SHADER_INFO->GetBytesRequired();
+        singleMatPropAlignedSize = device->PadSSBOSize(static_cast<uint32_t>(singleMatPropSize));
+        matPropTotalBytes = numTotalElements * singleMatPropAlignedSize;
+        if (matPropsDataSize < matPropTotalBytes)
         {
-          cmdBuffer->BindDescriptorSet
-          (
-            matPropsDescSet[frameIndex],
-            SH_PIPELINE_TYPE::GRAPHICS,
-            SHGraphicsConstants::DescriptorSetIndex::PER_INSTANCE,
-            dynamicOffset
+          matPropsData.reset(new char[matPropTotalBytes]);
+          matPropsDataSize = matPropTotalBytes;
+        }
+      }
+
+      // Build Sub Batches
+      uint32_t nextInstanceIndex = 0;
+      char* propsCurrPtr = matPropsData.get();
+      for (auto& subBatch : subBatches)
+      {
+        // Create command
+        const uint32_t CURR_INSTANCES = static_cast<uint32_t>(subBatch.Renderables.size());
+        drawData.emplace_back(vk::DrawIndexedIndirectCommand
+          {
+              .indexCount = subBatch.Mesh->IndexCount,
+              .instanceCount = CURR_INSTANCES,
+              .firstIndex = subBatch.Mesh->FirstIndex,
+              .vertexOffset = subBatch.Mesh->FirstVertex,
+              .firstInstance = nextInstanceIndex
+          });
+        nextInstanceIndex += CURR_INSTANCES;
+
+        // Fill in buffers (CPU)
+        for (auto rendId : subBatch.Renderables)
+        {
+          // Transform
+          auto transform = SHComponentManager::GetComponent_s<SHTransformComponent>(rendId);
+          if (!transform)
+          {
+            SHLOG_WARNING("[SHBatch] Entity contianing a SHRenderable with no SHTransformComponent found!");
+            transformData.emplace_back();
+          }
+          else
+          {
+            transformData.emplace_back(transform->GetTRS());
+          }
+
+          const SHRenderable* renderable = SHComponentManager::GetComponent<SHRenderable>(rendId);
+          instancedIntegerData.emplace_back(SHInstancedIntegerData
+            {
+              rendId,
+              renderable->GetLightLayer()
+            }
           );
-        }
-        cmdBuffer->DrawMultiIndirect(drawDataBuffer[frameIndex], static_cast<uint32_t>(drawData.size()));
-    }
 
-    /*---------------------------------------------------------------------------------*/
-    /* SHBatch - Helper Functions                                                      */
-    /*---------------------------------------------------------------------------------*/
-    void SHBatch::setAllDirtyFlags()
-    {
-        for (bool& dirt : isDirty)
-            dirt = true;
-        isCPUBuffersDirty = true;
-    }
-
-    void SHBatch::rebuildMaterialBuffers(uint32_t frameIndex, Handle<SHVkDescriptorPool> descPool)
-    {
-        if (matPropsData)
-        {
-            SHVkUtil::EnsureBufferAndCopyHostVisibleData
-            (
-                device, matPropsBuffer[frameIndex], matPropsData.get(), static_cast<uint32_t>(matPropsDataSize),
-                vk::BufferUsageFlagBits::eStorageBuffer
-            );
-
-            if (!matPropsDescSet[frameIndex])
+          // Material Properties
+          if (!EMPTY_MAT_PROPS)
+          {
+            if (renderable)
             {
-                matPropsDescSet[frameIndex] = descPool->Allocate
-                (
-                    { SHGraphicsGlobalData::GetDescSetLayouts()[SHGraphicsConstants::DescriptorSetIndex::PER_INSTANCE] },
-                    { 0 }
-                );
+              renderable->GetMaterial()->ExportProperties(propsCurrPtr);
             }
-            std::array<Handle<SHVkBuffer>, 1>  bufferList = { matPropsBuffer[frameIndex] };
-            matPropsDescSet[frameIndex]->ModifyWriteDescBuffer
-            (
-                SHGraphicsConstants::DescriptorSetIndex::PER_INSTANCE,
-                SHGraphicsConstants::DescriptorSetBindings::BATCHED_PER_INST_DATA,
-                bufferList,
-                0, static_cast<uint32_t>(matPropsDataSize)
-            );
-            matPropsDescSet[frameIndex]->UpdateDescriptorSetBuffer
-            (
-                SHGraphicsConstants::DescriptorSetIndex::PER_INSTANCE,
-                SHGraphicsConstants::DescriptorSetBindings::BATCHED_PER_INST_DATA
-            );
+            else
+            {
+              SHLOG_WARNING("[SHBatch] Entity with a missing SHRenderable found!");
+            }
+            propsCurrPtr += singleMatPropAlignedSize;
+          }
         }
+      }
+
+      // Successfully update CPU buffers
+      isCPUBuffersDirty = false;
     }
 
+    // Send all buffered data to the GPU buffers
+    using BuffUsage = vk::BufferUsageFlagBits;
+    // - Draw Data
+    const uint32_t DRAW_DATA_BYTES = static_cast<uint32_t>(drawData.size() * sizeof(vk::DrawIndexedIndirectCommand));
+    SHVkUtil::EnsureBufferAndCopyHostVisibleData
+    (
+      device, drawDataBuffer[frameIndex], drawData.data(), DRAW_DATA_BYTES,
+      BuffUsage::eIndirectBuffer
+    );
+    // - Transform Buffer
+    const uint32_t TF_DATA_BYTES = static_cast<uint32_t>(transformData.size() * sizeof(SHMatrix));
+    SHVkUtil::EnsureBufferAndCopyHostVisibleData
+    (
+      device, transformDataBuffer[frameIndex], transformData.data(), TF_DATA_BYTES,
+      BuffUsage::eVertexBuffer
+    );
+    const uint32_t EID_DATA_BYTES = static_cast<uint32_t>(instancedIntegerData.size() * sizeof(SHInstancedIntegerData));
+    SHVkUtil::EnsureBufferAndCopyHostVisibleData
+    (
+      device, instancedIntegerBuffer[frameIndex], instancedIntegerData.data(), EID_DATA_BYTES,
+      BuffUsage::eVertexBuffer
+    );
+    // - Material Properties Buffer
+    rebuildMaterialBuffers(frameIndex, descPool);
+
+    // Mark this frame as no longer dirty
+    isDirty[frameIndex] = false;
+  }
+
+  /*---------------------------------------------------------------------------------*/
+  /* SHBatch - Usage Functions                                                       */
+  /*---------------------------------------------------------------------------------*/
+  void SHBatch::Draw(Handle<SHVkCommandBuffer> cmdBuffer, uint32_t frameIndex)
+  {
+    if (frameIndex >= SHGraphicsConstants::NUM_FRAME_BUFFERS)
+    {
+      SHLOG_WARNING("[SHBatch] Attempted to draw a batch with an invalid frame index.");
+      return;
+    }
+
+    // Bind all required objects before drawing
+    static std::array<uint32_t, 1> dynamicOffset{ 0 };
+    cmdBuffer->BindPipeline(pipeline);
+    cmdBuffer->BindVertexBuffer(SHGraphicsConstants::VertexBufferBindings::TRANSFORM, transformDataBuffer[frameIndex], 0);
+    cmdBuffer->BindVertexBuffer(SHGraphicsConstants::VertexBufferBindings::INTEGER_DATA, instancedIntegerBuffer[frameIndex], 0);
+    if (matPropsDescSet[frameIndex])
+    {
+      cmdBuffer->BindDescriptorSet
+      (
+        matPropsDescSet[frameIndex],
+        SH_PIPELINE_TYPE::GRAPHICS,
+        SHGraphicsConstants::DescriptorSetIndex::PER_INSTANCE,
+        dynamicOffset
+      );
+    }
+    cmdBuffer->DrawMultiIndirect(drawDataBuffer[frameIndex], static_cast<uint32_t>(drawData.size()));
+  }
+
+  /*---------------------------------------------------------------------------------*/
+  /* SHBatch - Helper Functions                                                      */
+  /*---------------------------------------------------------------------------------*/
+  void SHBatch::setAllDirtyFlags()
+  {
+    for (bool& dirt : isDirty)
+      dirt = true;
+    isCPUBuffersDirty = true;
+  }
+
+  void SHBatch::rebuildMaterialBuffers(uint32_t frameIndex, Handle<SHVkDescriptorPool> descPool)
+  {
+    if (matPropsData)
+    {
+      SHVkUtil::EnsureBufferAndCopyHostVisibleData
+      (
+        device, matPropsBuffer[frameIndex], matPropsData.get(), static_cast<uint32_t>(matPropsDataSize),
+        vk::BufferUsageFlagBits::eStorageBuffer
+      );
+
+      if (!matPropsDescSet[frameIndex])
+      {
+        matPropsDescSet[frameIndex] = descPool->Allocate
+        (
+          { SHGraphicsGlobalData::GetDescSetLayouts()[SHGraphicsConstants::DescriptorSetIndex::PER_INSTANCE] },
+          { 0 }
+        );
+      }
+      std::array<Handle<SHVkBuffer>, 1>  bufferList = { matPropsBuffer[frameIndex] };
+      matPropsDescSet[frameIndex]->ModifyWriteDescBuffer
+      (
+        SHGraphicsConstants::DescriptorSetIndex::PER_INSTANCE,
+        SHGraphicsConstants::DescriptorSetBindings::BATCHED_PER_INST_DATA,
+        bufferList,
+        0, static_cast<uint32_t>(matPropsDataSize)
+      );
+      matPropsDescSet[frameIndex]->UpdateDescriptorSetBuffer
+      (
+        SHGraphicsConstants::DescriptorSetIndex::PER_INSTANCE,
+        SHGraphicsConstants::DescriptorSetBindings::BATCHED_PER_INST_DATA
+      );
+    }
+  }
+
 }
diff --git a/SHADE_Engine/src/Graphics/MiddleEnd/Batching/SHBatch.h b/SHADE_Engine/src/Graphics/MiddleEnd/Batching/SHBatch.h
index a7124e05..de137b28 100644
--- a/SHADE_Engine/src/Graphics/MiddleEnd/Batching/SHBatch.h
+++ b/SHADE_Engine/src/Graphics/MiddleEnd/Batching/SHBatch.h
@@ -56,7 +56,7 @@ namespace SHADE
         /* Data Members                                                                */
         /*-----------------------------------------------------------------------------*/
         Handle<SHMesh> Mesh;
-        std::unordered_set<const SHRenderable*> Renderables;
+        std::unordered_set<EntityID> Renderables;
     };
     /***********************************************************************************/
     /*!
diff --git a/SHADE_Engine/src/Graphics/MiddleEnd/Interface/SHGraphicsSystem.cpp b/SHADE_Engine/src/Graphics/MiddleEnd/Interface/SHGraphicsSystem.cpp
index 7b8b9e45..9b984a4b 100644
--- a/SHADE_Engine/src/Graphics/MiddleEnd/Interface/SHGraphicsSystem.cpp
+++ b/SHADE_Engine/src/Graphics/MiddleEnd/Interface/SHGraphicsSystem.cpp
@@ -700,10 +700,10 @@ namespace SHADE
         continue;
     
       // Remove from old material's SuperBatch
-      Handle<SHMaterial> prevMaterial = renderable.GetPrevMaterial();
+      Handle<SHMaterialInstance> prevMaterial = renderable.GetPrevMaterial();
       if (prevMaterial)
       {
-        Handle<SHSuperBatch> oldSuperBatch = prevMaterial->GetPipeline()->GetPipelineState().GetSubpass()->GetSuperBatch();
+        Handle<SHSuperBatch> oldSuperBatch = prevMaterial->GetBaseMaterial()->GetPipeline()->GetPipelineState().GetSubpass()->GetSuperBatch();
         oldSuperBatch->Remove(&renderable);
       }
     
